#
# AitCS timings
#
# Stuart Cassoff
# Fall 2020
#


package require aitcs

namespace eval ::aitcs { namespace eval tests { namespace eval timings {


proc go {{timer {time}}} {
	namespace import ::aitcs::aitcs ::aitcs::aitcs+
	set timer [string trimleft $timer -]
	if {$timer eq "time"} {
		set n 10000
		set t {}
	} elseif {$timer eq "timerate"} {
		set n {}
		set t 1000
		timerate -calibrate {}
	} else {
		return -code error "bad timer \"$timer\": must be time, or timerate"
	}
	if {$::tcl_platform(engine) eq "Jim"} {
		set fmt {%-10s %5.1f}
	} else {
		set fmt {%-10s %10.6f}
	}

variable _v_; array set _v_ {}
	aitcs+ new a
# -cns [namespace current] -vns [namespace [expr {0 ? "current" : "parent"}]]
	foreach what [list {*}{
		{a? z}
		{a? z v}
		{a^ z}
		{a^ z 1}
		{a z 1}
		{a? z}
		{a? z v}
		{a^ z}
		{a^ z 1}
		{a z}
		{a+= z}
		{a+= z -1}
		{a+= z 1 2}
		{a= y 1 2 0}
		{:a x {}}
		{a+ x 1 2 3}
		{a&}
		{a& z}
		{a&&}
		{a!}
		{a- z}
		{a q 1;a- q}
		{:aitcs new r}
		{r j 1}
		{a y r}
		{a-> y j 2}
		{a-> y? j}
		{a-> y^ k}
		{:r---}
		{aitcs new b;b---}
	}] {
		if {[string index $what 0] eq ":"} {
			#puts [format $fmt $what [lindex [$timer [string range $what 1 end] {*}$t 1] 0]]
			eval [string range $what 1 end]
		} else {
if {[catch {			puts [format $fmt [string map {"aitcs " ""} $what] [lindex [$timer $what {*}$n] 0]]}]} {
puts $::errorInfo
}
		}
	}
}


}}}; # ::aitcs::tests::timings


::aitcs::tests::timings::go {*}$::argv


# EOF
