#
# AitCS tightloop
#
# Stuart Cassoff
# Fall 2021
#


package require aitcs

namespace eval ::aitcs { namespace eval tests { namespace eval tightloop {


proc tcl/jim {n} {
	variable tdata
	variable ttemp
	for {set i 0} {$i < $n} {incr i} {
		set ttemp($i) $tdata($i)
	}
}

proc full {n} {
	for {set i 0} {$i < $n} {incr i} {
		temp $i [data $i]
	}
}

proc partial {n} {
	data! ; temp!
	for {set i 0} {$i < $n} {incr i} {
		set temp($i) $data($i)
	}
}

proc go {{timer {time}}} {
	namespace import ::aitcs::aitcs
	set timer [string trimleft $timer -]
	if {$timer eq "time"} {
		set n 10000
		set t {}
	} elseif {$timer eq "timerate"} {
		set n {}
		set t 1000
		timerate -calibrate {}
	} else {
		return -code error "bad timer \"$timer\": must be time, or timerate"
	}
	if {$::tcl_platform(engine) eq "Jim"} {
		set fmt {%-20s %5.1f %5.1f %8.2f%%}
	} else {
		set fmt {%-20s %10.6f %10.6f %8.2f%%}
	}

	aitcs new parms
	aitcs new data
	aitcs new temp
	for {set i 0} {$i < 1000} {incr i} {
		data $i $i
		temp $i $i
	}

	set nitemslist [list 0 1 10 100 1000]
	puts [format "method / nitems[string repeat "\t%d" [llength $nitemslist]]" {*}$nitemslist]
	foreach method {full partial} {	
		puts -nonewline $method\t
		flush stdout
		foreach nitems {0 1 10 100 1000} {
			temp- *
			parms nitems $nitems
			set t [lindex [$timer {$method $nitems} {*}$n] 0]
			puts -nonewline \t[set t]
			flush stdout
		}
		puts ""
	}

	variable tdata
	variable ttemp
	for {set i 0} {$i < 1000} {incr i} {
		set tdata($i) $i
		set ttemp($i) $i
	}

	foreach method {tcl/jim} {	
		puts -nonewline $method\t
		flush stdout
		foreach nitems {0 1 10 100 1000} {
			array unset ttemp *
			parms nitems $nitems
			set t [lindex [$timer {$method $nitems} {*}$n] 0]
			puts -nonewline \t[set t]
			flush stdout
		}
		puts ""
	}
}


}}}; # ::aitcs::tests::tightloop


::aitcs::tests::tightloop::go {*}$::argv


# EOF
