#
# AitCS vs
#
# Stuart Cassoff
# Fall 2020
#


package require aitcs

namespace eval ::aitcs { namespace eval tests { namespace eval vs {


proc set_a {elem val} {
	aa $elem $val
}

proc set_t {elem val} {
	variable ta
	set ta($elem) $val
}

proc get_a {elem} {
	aa $elem
}

proc get_t {elem} {
	variable ta
	return $ta($elem)
}

proc unset_a {elem} {
	aa- $elem
}

proc unset_t {elem} {
	variable ta
	array unset ta $elem
}

proc exists_a {elem} {
	aa? $elem
}

proc exists_t {elem} {
	variable ta
	info exists ta($elem)
}

proc gwd_a {elem {def {}}} {
	aa^ $elem $def
}

proc gwd_t {elem {def {}}} {
	variable ta
	if {[info exists ta($elem)]} {
		return $ta($elem)
	} else {
		return $def
	}
}

proc mkexist_a {} {
	aa!
}

proc mkexist_t {} {
	variable ta
}

proc aref_a {} {
	aa&
}

proc aref_t {} {
	return [namespace current]::ta
}

proc eref_a {elem} {
	aa& $elem
}

proc eref_t {elem} {
	return [namespace current]::ta($elem)
}

proc cref_a {} {
	aa&&
}

proc cref_t {} {
	variable ta
	namespace which -variable ta
}

proc setto_a {args} {
	aa= {*}$args
}

proc setto_t {args} {
	variable ta
	set v [lindex $args end]
	foreach e [lrange $args 0 end-1] {
		set ta($e) $v
	}
}

proc lappend_a {elem args} {
	aa+ $elem {*}$args
}

proc lappend_t {elem args} {
	variable ta
	lappend ta($elem) {*}$args
}

proc incr_a {elem} {
	aa+= $elem
}

proc incr_t {elem} {
	variable ta
	incr ta($elem)
}


proc go {{timer {time}}} {
	namespace import ::aitcs::aitcs ::aitcs::aitcs+
	set timer [string trimleft $timer -]
	if {$timer eq "time"} {
		set n 10000
		set t {}
	} elseif {$timer eq "timerate"} {
		set n {}
		set t 1000
		timerate -calibrate {}
	} else {
		return -code error "bad timer \"$timer\": must be time, or timerate"
	}
	if {$::tcl_platform(engine) eq "Jim"} {
		set fmt {%-20s %5.1f %5.1f %8.2f%%}
		puts [format {%-20s %5s %5s %9s} Operation AitCS Jim Change]
	} else {
		set fmt {%-20s %10.6f %10.6f %8.2f%%}
		puts [format {%-20s %10s %10s %9s} Operation AitCS Tcl Change]
	}

	aitcs+ new aa
	variable ta; array set ta {}

	foreach what [list {*}{
		{exists z}
		{set z 1}
		{exists z}
		{get z}
		{set l {}}
		{lappend l a b c}
		{unset l}
		{incr z}
		{mkexist}
		{gwd z}
		{gwd q 3}
		{setto a b c d e 0}
		{eref z}
		{aref}
		{cref}
	}] {
		set r [list $what]
		foreach which {a t} {
			set a [lassign $what c]
			set w [linsert $a 0 [string cat $c _ $which]]
			set t_$which [lindex [$timer $w {*}$n] 0]
			lappend r [set t_$which]
		}
		lappend r [expr {(($t_a * 1.0) / $t_t)*100}]
		puts [format $fmt {*}$r]
	}
}


}}}; # ::aitcs::tests::vs


::aitcs::tests::vs::go {*}$::argv


# EOF
